unit ip_utils;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,ctypes,strutils{$IFDEF UNIX} ,BaseUnix,Sockets{$ENDIF}{$IFDEF WINDOWS},Winsock {$ENDIF};

function GetLocalIP: string;

const IF_NAMESIZE = 16;
IFNAMSIZ = IF_NAMESIZE;

implementation

function GetLocalIP: string;
{$IFDEF UNIX}
type
  __caddr_t = char;

   Pifmap = ^ifmap;
   ifmap = record
        mem_start : dword;
        mem_end : dword;
        base_addr : word;
        irq : byte;
        dma : byte;
        port : byte;
     end;

   Pifreq = ^ifreq;
   ifreq = record
        ifr_ifrn : record
            case longint of
               0 : ( ifrn_name : array[0..(IFNAMSIZ)-1] of char );
            end;
        ifr_ifru : record
            case longint of
               0 : ( ifru_addr : sockaddr );
               1 : ( ifru_dstaddr : sockaddr );
               2 : ( ifru_broadaddr : sockaddr );
               3 : ( ifru_netmask : sockaddr );
               4 : ( ifru_hwaddr : sockaddr );
               5 : ( ifru_flags : smallint );
               6 : ( ifru_ivalue : longint );
               7 : ( ifru_mtu : longint );
               8 : ( ifru_map : ifmap );
               9 : ( ifru_slave : array[0..(IFNAMSIZ)-1] of char );
               10 : ( ifru_newname : array[0..(IFNAMSIZ)-1] of char );
               11 : ( ifru_data : __caddr_t );
            end;
     end;

var
  I:Integer;
  VStrTemp,VStrTempRes: TStringList;
  sockaddr_:ifreq;
  socket_:cint;
  const SIOCGIFADDR = $8915;
{$ENDIF}
{$IFDEF MSWINDOWS}
var
  VWSAData: TWSAData;
  VHostEnt: PHostEnt;
  VName: string;
  const CFormatIPMask = '%d.%d.%d.%d';
{$ENDIF}
begin
  Result := '';
{$IFDEF UNIX}
  VStrTemp := TStringList.Create;
  VStrTempRes := TStringList.Create;
  VStrTempRes.Clear;
  VStrTempRes.Sorted:=true;
  VStrTempRes.Duplicates:=dupIgnore;
  VStrTemp.LoadFromFile('/proc/net/route');

  for i:=0 to VStrTemp.Count-1 do
  begin
    if ExtractWord(4,VStrTemp[i],[#9])='0001' then VStrTempRes.Add(ExtractWord(1,VStrTemp[i],[#9]));  // 0001 Флаг U в таблице маршрутизации
  end;

  socket_:=fpsocket(AF_INET,SOCK_DGRAM,0);
  sockaddr_.ifr_ifrn.ifrn_name:=VStrTempRes[0];

  FpIOCtl(socket_,SIOCGIFADDR,@sockaddr_);
  CloseSocket(socket_);

  Result:='';;
  for i:=1 to 4 do Result:=Result+IntToStr(sockaddr_.ifr_ifru.ifru_addr.sin_addr.s_bytes[i])+'.';
  Result:=Copy(Result,1,Length(Result)-1);
  FreeAndNil(VStrTemp);
  FreeAndNil(VStrTempRes);
{$ENDIF}
{$IFDEF MSWINDOWS}
{$HINTS OFF}
  WSAStartup(2, VWSAData);
{$HINTS ON}
  SetLength(VName, 255);
  GetHostName(PChar(VName), 255);
  SetLength(VName, StrLen(PChar(VName)));
  VHostEnt := GetHostByName(PChar(VName));
  with VHostEnt^ do
    Result := Format(CFormatIPMask, [Byte(h_addr^[0]), Byte(h_addr^[1]),
      Byte(h_addr^[2]), Byte(h_addr^[3])]);
  WSACleanup;
{$ENDIF}
end;

end.

